Pie dough nut in JavaScript Accumulation chart control

18 Nov 201824 minutes to read

Pie chart

To render a pie series, use the series type as Pie and inject the PieSeries module using AccumulationChart.Inject(PieSeries) method. If the PieSeries module is not injected, this module will be loaded by default.

var piechart = new ej.charts.AccumulationChart({
    series: [
        {
            dataSource: [{ x: 'Jan', y: 3 }, { x: 'Feb', y: 3.5 }, { x: 'Mar', y: 7 }, { x: 'Apr', y: 13.5 },
            { x: 'May', y: 19 }, { x: 'Jun', y: 23.5 }, { x: 'Jul', y: 26 }, { x: 'Aug', y: 25 },
            { x: 'Sep', y: 21 }, { x: 'Oct', y: 15 }],
            radius: '100%',
            xName: 'x',
            yName: 'y'
        }
    ],
	tooltip:{enable: true}
}, '#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Radius customization

By default, radius of the pie series will be 80% of the size (minimum of chart width and height). You can customize this using radius property of the series.

var piechart = new ej.charts.AccumulationChart({
    series: [
        {
            dataSource: [{ x: 'Jan', y: 3 }, { x: 'Feb', y: 3.5 }, { x: 'Mar', y: 7 }, { x: 'Apr', y: 13.5 },
            { x: 'May', y: 19 }, { x: 'Jun', y: 23.5 }, { x: 'Jul', y: 26 }, { x: 'Aug', y: 25 },
            { x: 'Sep', y: 21 }, { x: 'Oct', y: 15 }],
            radius: '100%',
            xName: 'x',
            yName: 'y'
        }
    ],
	tooltip:{enable: true}
}, '#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Pie center

The center position of the pie can be changed by Center X and Center Y. By default, center value of the pie series x and y is 50%. You can customize this using center property of the series.

var piechart = new ej.charts.AccumulationChart({
    series: [
        {
            dataSource: [{ x: 'Jan', y: 3 }, { x: 'Feb', y: 3.5 }, { x: 'Mar', y: 7 }, { x: 'Apr', y: 13.5 },
            { x: 'May', y: 19 }, { x: 'Jun', y: 23.5 }, { x: 'Jul', y: 26 }, { x: 'Aug', y: 25 },
            { x: 'Sep', y: 21 }, { x: 'Oct', y: 15 }],
            radius: '100%',
            xName: 'x',
            yName: 'y',
            enter: {x: '60%', y: '60%'},
        }
    ],
	tooltip:{enable: true}
}, '#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Various radius pie chart

You can use radius mapping to render the slice with different radius pie and also use border , fill properties to customize the point. dataLabel is used to represent individual data and its value.

var piechart = new ej.charts.AccumulationChart({
   series: [
            {

                dataSource: [
                    { x: 'Argentina', y: 505370, r: '100' },
                    { x: 'Belgium', y: 551500, r: '118.7' },
                    { x: 'Cuba', y: 312685, r: '124.6' },
                    { x: 'Dominican Republic', y: 350000, r: '137.5' },
                    { x: 'Egypt', y: 301000, r: '150.8' },
                    { x: 'Kazakhstan', y: 300000, r: '155.5' },
                    { x: 'Somalia', y: 357022, r: '160.6' }

                ],
                dataLabel: {
                    visible: true, position: 'Outside',
                    name: 'x'

                },
                radius: 'r', xName: 'x',
                yName: 'y', innerRadius: '20%'
            },

        ],
        enableSmartLabels: true,
        legendSettings: {
            visible: true,
        },
        enableAnimation: true,
        title: 'Countries compared by population density and total area'
}, '#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Doughnut chart

To achieve a doughnut in pie series, customize the innerRadius property of the series. By setting value greater than 0%, a doughnut will appear. The innerRadius property takes value from 0% to 100% of the pie radius.

var piechart = new ej.charts.AccumulationChart({
    series: [
        {
            dataSource: [{ x: 'Jan', y: 3 }, { x: 'Feb', y: 3.5 }, { x: 'Mar', y: 7 }, { x: 'Apr', y: 13.5 },
            { x: 'May', y: 19 }, { x: 'Jun', y: 23.5 }, { x: 'Jul', y: 26 }, { x: 'Aug', y: 25 }],
            innerRadius: '40%',
            xName: 'x',
            yName: 'y'
        }
    ]
}, '#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Multiple Donut

You can create multiple donuts within a single chart by adding multiple series with different innerRadius and radius values. This allows you to compare multiple data sets with the same categories. Each series can have different data, colors, and customizations. You can also use the mappingKey property in legendSettings to map the legend items based on the specified field from the data source. When set, points with matching mappingKey values are grouped into a single legend item.

// Creating separate series data with same x values but different y values
var totalSalesData = [
    { x: 'Electronics', y: 45000, text: '45K' },
    { x: 'Fashion', y: 32000, text: '32K' },
    { x: 'Home & Garden', y: 18000, text: '18K' },
    { x: 'Sports', y: 15000, text: '15K' },
    { x: 'Books', y: 8000, text: '8K' }
];

// Same x values as totalSalesData but different y values (profit)
var totalProfitData = [
    { x: 'Electronics', y: 18000, text: '18K', profit: '40%' },
    { x: 'Fashion', y: 12800, text: '12.8K', profit: '40%' },
    { x: 'Home & Garden', y: 6300, text: '6.3K', profit: '35%' },
    { x: 'Sports', y: 4500, text: '4.5K', profit: '30%' },
    { x: 'Books', y: 2400, text: '2.4K', profit: '30%' }
];

var piechart = new ej.charts.AccumulationChart({
    title: 'Product Sales vs Profit Analysis',
    subtitle: { text: 'Comparing total sales revenue with profit margins by product category' },
    series: [{
        name: 'Total Sales',
        dataSource: totalSalesData,
        xName: 'x',
        yName: 'y',
        innerRadius: '60%',
        radius: '90%',
        dataLabel: { 
            name: 'text', 
            visible: true, 
            position: 'Outside',
            connectorStyle: { type: 'Curve', color: 'black', width: 2, dashArray: '2,1', length: '5' }
        },
        tooltipMappingName: 'x'
    },
    {
        name: 'Total Profit',
        dataSource: totalProfitData,
        xName: 'x',
        yName: 'y',
        innerRadius: '50%',
        radius: '50%',
        dataLabel: { 
            name: 'text', 
            visible: true, 
            position: 'Inside',
            connectorStyle: { type: 'Curve', color: 'black', width: 2, dashArray: '2,1', length: '5' }
        },
        tooltipMappingName: 'x'
    }],
    tooltip: {
        enable: true,
        format: '<b>${point.x}</b><br/>Value: <b>$${point.y}</b><br/>Percentage: <b>${point.percentage}%</b>'
    },
    legendSettings: {
        mappingKey: 'x'
    },
    enableBorderOnMouseMove: false,
    border: { color: '#333', width: 2 }
}, '#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Start and end angles

You can customize the start and end angle of the pie series using the startAngle and endAngle properties. The default value of startAngle is 0 degree, and endAngle is 360 degrees. By customizing this, you can achieve a semi pie series.

var piechart = new ej.charts.AccumulationChart({
    series: [
        {
            dataSource: [
                { x: 'Jan', y: 3, text: 'Jan: 3' }, { x: 'Feb', y: 3.5, text: 'Feb: 3.5' },
                { x: 'Mar', y: 7, text: 'Mar: 7' }, { x: 'Apr', y: 13.5, text: 'Apr: 13.5' },
                { x: 'May', y: 19, text: 'May: 19' }, { x: 'Jun', y: 23.5, text: 'Jun: 23.5' },
                { x: 'Jul', y: 26, text: 'Jul: 26' }, { x: 'Aug', y: 25, text: 'Aug: 25' },
                { x: 'Sep', y: 21, text: 'Sep: 21' }, { x: 'Oct', y: 15, text: 'Oct: 15' }],
            dataLabel: { visible: true, name: 'text', position: 'Outside'  },
            startAngle: 270,
            endAngle: 90,
            xName: 'x',
            yName: 'y'
        }
    ]
}, '#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Color & text mapping

The fill color and the text in the data source can be mapped to the chart using pointColorMapping in series and name in datalabel respectively.

var piechart = new ej.charts.AccumulationChart({
    series: [
        {
            dataSource: [
                { x: 'Jan', y: 3, text: 'Jan: 3' }, { x: 'Feb', y: 3.5, text: 'Feb: 3.5' },
                { x: 'Mar', y: 7, text: 'Mar: 7' }, { x: 'Apr', y: 13.5, text: 'Apr: 13.5' },
                { x: 'May', y: 19, text: 'May: 19' }, { x: 'Jun', y: 23.5, text: 'Jun: 23.5' },
                { x: 'Jul', y: 26, text: 'Jul: 26' }, { x: 'Aug', y: 25, text: 'Aug: 25' },
                { x: 'Sep', y: 21, text: 'Sep: 21' }, { x: 'Oct', y: 15, text: 'Oct: 15' }],
            dataLabel: { visible: true, name: 'text', position: 'Outside'  },
            startAngle: 270,
            endAngle: 90,
            xName: 'x',
            yName: 'y'
        }
    ]
}, '#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Border radius

You can create rounded corners for each slice by using the borderRadius option, which gives the chart a modern and polished appearance.

var piechart = new ej.charts.AccumulationChart({
    series: [
        {
            dataSource: [{ x: 'Jan', y: 3 }, { x: 'Feb', y: 3.5 }, { x: 'Mar', y: 7 }, { x: 'Apr', y: 13.5 },
            { x: 'May', y: 19 }, { x: 'Jun', y: 23.5 }, { x: 'Jul', y: 26 }, { x: 'Aug', y: 25 },
            { x: 'Sep', y: 21 }, { x: 'Oct', y: 15 }],
            radius: '100%',
            xName: 'x',
            yName: 'y',
            borderRadius: 8
        }
    ],
	tooltip:{enable: true}
}, '#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Palette

The default palette for the pie series can be customized by using the palettes property in the series.

var piechart = new ej.charts.AccumulationChart({
    series: [
        {
            dataSource: [{ x: 'Jan', y: 3 }, { x: 'Feb', y: 3.5 }, { x: 'Mar', y: 7 }, { x: 'Apr', y: 13.5 },
            { x: 'May', y: 19 }, { x: 'Jun', y: 23.5 }, { x: 'Jul', y: 26 }, { x: 'Aug', y: 25 },
            { x: 'Sep', y: 21 }, { x: 'Oct', y: 15 }],
            radius: '100%',
            xName: 'x',
            yName: 'y',
            palettes: ['#0078D7', '#00B294', '#E671B8', '#FEB81D', '#108EE9', '#3D9970', '#E51400', '#6BA5D7', '#FFB900', '#F28F44']
        }
    ],
	tooltip:{enable: true}
}, '#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Customization

Individual points can be customized using the pointRender event.

var piechart = new ej.charts.AccumulationChart({
    series: [
        {
            dataSource: [
                { x: 'Jan', y: 3, text: 'Jan: 3' }, { x: 'Feb', y: 3.5, text: 'Feb: 3.5' },
                { x: 'Mar', y: 7, text: 'Mar: 7' }, { x: 'Apr', y: 13.5, text: 'Apr: 13.5' },
                { x: 'May', y: 19, text: 'May: 19' }, { x: 'Jun', y: 23.5, text: 'Jun: 23.5' },
                { x: 'Jul', y: 26, text: 'Jul: 26' }, { x: 'Aug', y: 25, text: 'Aug: 25' },
                { x: 'Sep', y: 21, text: 'Sep: 21' }, { x: 'Oct', y: 15, text: 'Oct: 15' },
                { x: 'Nov', y: 9, text: 'Nov: 9' }, { x: 'Dec', y: 3.5, text: 'Dec: 3.5' }],
            dataLabel: { visible: true, name: 'text', position: 'Outside' },
            groupTo: '11',
            xName: 'x',
            yName: 'y'
        }
    ],
    textRender: (args) => {
        if (args.text.indexOf('Others') > -1) {
            args.color = 'red';
            args.border.width = 1;
        }
    },
    pointRender: (args) => {
        if ((args.point.x).indexOf('Others') > -1) {
            args.fill = '#D3D3D3';
        }
    },
}, '#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Patterns

You can apply different patterns to the pie slices using the applyPattern property in the series and the pointRender event.

var piechart = new ej.charts.AccumulationChart({
    series: [
        {
            dataSource: [{ x: 'Jan', y: 3 }, { x: 'Feb', y: 3.5 }, { x: 'Mar', y: 7 }, { x: 'Apr', y: 13.5 },
            { x: 'May', y: 19 }, { x: 'Jun', y: 23.5 }, { x: 'Jul', y: 26 }, { x: 'Aug', y: 25 },
            { x: 'Sep', y: 21 }, { x: 'Oct', y: 15 }],
            radius: '100%',
            xName: 'x',
            yName: 'y',
            applyPattern: true
        }
    ],
	tooltip:{enable: true}
}, '#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Hide pie or doughnut border

By default, the border will appear in the pie/doughnut chart while mouse hover on the chart. You can disable the the border by setting enableBorderOnMouseMove property is false.

var dataMapping = [{ x: 'Jan', y: 3, fill: '#498fff', text:'January' }, { x: 'Feb', y: 3.5, fill: '#ffa060', text: 'February' },
    { x: 'Mar', y: 7, fill: '#ff68b6', text: 'March' }, { x: 'Apr', y: 13.5, fill: '#81e2a1', text: 'April' }];

var chart = new ej.charts.AccumulationChart({
   enableBorderOnMouseMove: false,
    series: [
        {
            dataSource: dataMapping,
            xName: 'x',
            yName: 'y',
        }
    ]
}, '#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Multi-level pie chart

You can achieve a multi-level drill down in pie and doughnut charts using pointClick event. If user clicks any point in the chart, that corresponding data will be shown in the next level and so on based on point clicked.

You can also achieve drill-up (back to the initial state) by using chartMouseClick event. In below sample, you can drill-up by clicking back button in the center of the chart.

window.pointIndex = -1;
var data = [
  {
    x: 'SUV',
    y: 25,
    z: [
      {
        title: 'Automobile Sales in the SUV Segment',
        x: 'Toyota',
        y: 8,
        z: [
          { x: '2000', y: 20 },
          { x: '2001', y: 30 },
          { x: '2002', y: 40 },
        ],
      },
      { x: 'Ford', y: 12 },
      { x: 'GM', y: 17 },
      { x: 'Renault', y: 6 },
    ],
  },
  {
    x: 'Car',
    y: 37,
    z: [
      { title: 'Automobile Sales in the Car Segment', x: 'Toyota', y: 7 },
      { x: 'Chrysler', y: 12 },
      { x: 'Nissan', y: 9 },
      { x: 'Ford', y: 15 },
    ],
  },
  {
    x: 'Pickup',
    y: 15,
    z: [
      { title: 'Automobile Sales in the Pickup Segment', x: 'Nissan', y: 9 },
      { x: 'Chrysler', y: 4 },
      { x: 'Ford', y: 7 },
      { x: 'Toyota', y: 20 },
    ],
  },
  {
    x: 'Minivan',
    y: 23,
    z: [
      { title: 'Automobile Sales in the Minivan Segment', x: 'Hummer', y: 11 },
      { x: 'Ford', y: 5 },
      { x: 'GM', y: 12 },
      { x: 'Chrysler', y: 3 },
    ],
  },
];

var click = function (args) {
  if (pie.series[0].name !== 'Level 3') {
    switch (args.pointIndex) {
      case 0:
        pie.series[0].dataSource = data[0].z[0].z;
        pie.title = 'SUV Sales by Years';
        pie.series[0].name = 'Level 3';
        grid.columns[0].headerText = 'Year';
        grid.refresh();
        pie.refresh();
        break;
    }
    grid.dataSource = pie.series[0].dataSource;
  }
};
var pointClick = function (args) {
  if (ej.charts.getElement(pie.element.id + '_Series_' + args.seriesIndex + '_Point_' + args.pointIndex)) {
    pie.series[0].dataSource = data[args.pointIndex].z;
    pie.title = data[args.pointIndex].z[0].title;
    window.pointIndex = args.pointIndex;

    pie.series[0].name = 'Level 2';
    pie.series[0].innerRadius = '30%';
    pie.annotations = [
      {
        content:
          '<div id="back" style="cursor:pointer;padding:3px;width:30px; height:30px;">' +
          '<img src="https://ej2.syncfusion.com/javascript/demos/src/chart/images/back.png" id="back" />',
        region: 'Series',
        x: '50%',
        y: '50%',
      },
    ];
    pie.pointClick = click;
    var secondlevelpie = pie;
  }
  grid.dataSource = pie.series[0].dataSource;
  grid.columns[0].headerText = data[args.pointIndex].x;
};

var instance = {
  series: [
    {
      dataSource: data,
      dataLabel: {
        visible: true,
        position: 'Inside',
      },
      radius: '70%',
      xName: 'x',
      yName: 'y',
      startAngle: 0,
      endAngle: 360,
      innerRadius: '0%',
      name: 'Level 1',
    },
  ],
  enableSmartLabels: false,
  legendSettings: { visible: true },
  chartMouseClick: (args) => {
    if (args.target.indexOf('back') > -1) {
      if (pie.series[0].name === 'Level 3') {
        pie.series[0].dataSource = data[window.pointIndex].z;
        pie.series[0].name = 'Level 2';
        pie.title = data[window.pointIndex].z[0].title;
        pie.series[0].innerRadius = '30%';
        grid.dataSource = pie.series[0].dataSource;
        grid.columns[0].headerText = data[window.pointIndex].x;
        grid.refresh();
        pie.refresh();
      } else if (pie.series[0].name === 'Level 2') {
        pie.series[0].dataSource = data;
        pie.series[0].name = 'Level 1';
        pie.series[0].innerRadius = '0%';
        pie.title = 'Automobile Sales by Category';
        pie.annotations = [{}];
        pie.pointClick = pointClick;
        grid.dataSource = pie.series[0].dataSource;
        grid.columns[0].headerText = 'Vehicle';
      }
    }
    grid.dataSource = pie.series[0].dataSource;
  },
  pointClick: pointClick,
  title: 'Automobile Sales by Category',
};
var pie = new ej.charts.AccumulationChart(instance);
pie.appendTo('#container');

var grid = new ej.grids.Grid({
  dataSource: data,
  columns: [
    { field: 'x', headerText: 'Vehicle', type: 'string' },
    { field: 'y', headerText: 'Sales', type: 'string' },
  ],
});
grid.appendTo('#Grid');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/material.css" rel="stylesheet">
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>

<body>
    
    <div class="control-section">
      <div id="link">
          <a id="category" style="visibility:hidden; display:inline-block">
            Sales by Category 
      </a>
          <p style="visibility:hidden; display:inline-block" id="symbol">&nbsp;&gt;&gt;&nbsp;</p>
          <p id="text" style="display:inline-block;"></p>
      </div>
      <div id="container"></div>
  </div>
  
 
<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

See also

Pie dough nut in Angular Accumulation chart component

18 Nov 201824 minutes to read

Pie Chart

To render a pie series, use the series type as Pie and inject the PieSeriesService module into the @NgModule.providers. If the PieSeries module is not injected, this module will be loaded by default.

To known about circular and triangular charts, you can check on this video:

import { AccumulationChartModule } from '@syncfusion/ej2-angular-charts'
import { PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationAnnotationService,
  AccumulationDataLabelService } from '@syncfusion/ej2-angular-charts'


import { Component, OnInit } from '@angular/core';
import { pieData } from './datasource';
@Component({
imports: [
         AccumulationChartModule
    ],

providers: [PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationDataLabelService,
     AccumulationAnnotationService],
standalone: true,
    selector: 'app-container',
    template: `<ejs-accumulationchart id="chart-container" [legendSettings]='legendSettings'>
        <e-accumulation-series-collection>
            <e-accumulation-series [dataSource]='piedata' xName='x' yName='y' type='Pie'></e-accumulation-series>
        </e-accumulation-series-collection>
    </ejs-accumulationchart>`
})
export class AppComponent implements OnInit {
    public piedata?: Object[];
    public legendSettings?: Object;
    ngOnInit(): void {
        this.piedata = pieData;
        this.legendSettings = {
            visible: false
        };
    }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Radius Customization

By default, radius of the pie series will be 80% of the size (minimum of chart width and height).
You can customize this using radius property of the series.

import { AccumulationChartModule } from '@syncfusion/ej2-angular-charts'
import { PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationAnnotationService,
  AccumulationDataLabelService } from '@syncfusion/ej2-angular-charts'


import { Component, OnInit } from '@angular/core';
import { pieData } from './datasource';
@Component({
imports: [
         AccumulationChartModule
    ],

providers: [PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationDataLabelService,
     AccumulationAnnotationService],
standalone: true,
    selector: 'app-container',
    template: `<ejs-accumulationchart id="chart-container" [legendSettings]='legendSettings'>
        <e-accumulation-series-collection>
            <e-accumulation-series [dataSource]='piedata' xName='x' yName='y' radius="100%"></e-accumulation-series>
        </e-accumulation-series-collection>
    </ejs-accumulationchart>`
})
export class AppComponent implements OnInit {
    public piedata?: Object[];
    public legendSettings?: Object;
    ngOnInit(): void {
        this.piedata = pieData;
        this.legendSettings = {
            visible: false
        };
    }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Pie Center

The center position of the pie can be changed by Center X and Center Y. By default, center value of the pie series x and y is 50%. You can customize this using center property of the series.

import { AccumulationChartModule } from '@syncfusion/ej2-angular-charts'
import { PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationAnnotationService,
  AccumulationDataLabelService } from '@syncfusion/ej2-angular-charts'


import { Component, OnInit } from '@angular/core';
import { data } from './datasource';
@Component({
imports: [
         AccumulationChartModule
    ],

providers: [PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationDataLabelService,
     AccumulationAnnotationService],
standalone: true,
    selector: 'app-container',
    template: `<ejs-accumulationchart id="container" width='92%' [legendSettings]="legendSettings" [title]="title" [enableAnimation]= 'enableAnimation' [center]='center'>
            <e-accumulation-series-collection>
                <e-accumulation-series name='Browser' [dataSource]='pieData' xName='x' yName='y' [startAngle]="startAngle" [endAngle]="endAngle" innerRadius="0%" radius="70%" [explode]='explode' explodeOffset='10%' [explodeIndex]='0'>
                </e-accumulation-series>
            </e-accumulation-series-collection>
    </ejs-accumulationchart>`
})
export class AppComponent implements OnInit {
    public pieData?: Object[];
    public startAngle?: number;
    public endAngle?: number;
    public center?: Object ;
    public explode?: boolean ;
    public enableAnimation?: boolean ;
    public title?: string ;
    public legendSettings?: Object;
    ngOnInit(): void {
    this.pieData = data;
        this.legendSettings = {
            visible: false
        };
    this.center = {x: '60%', y: '60%'};
    this.startAngle = 0;
    this.endAngle = 360;
    this.explode = true;
    this.enableAnimation = false;
    this.title = 'Mobile Browser Statistics';
    }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Various Radius Pie Chart

You can use radius mapping to render the slice with different radius pie and also use border , fill properties to customize the point. dataLabel is used to represent individual data and its value.

import { AccumulationChartModule } from '@syncfusion/ej2-angular-charts'
import { PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationAnnotationService,
  AccumulationDataLabelService } from '@syncfusion/ej2-angular-charts'


import { Component, OnInit } from '@angular/core';
import { variespiedata } from './datasource';
@Component({
imports: [
         AccumulationChartModule
    ],

providers: [PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationDataLabelService,
     AccumulationAnnotationService],
standalone: true,
    selector: 'app-container',
    template: `<ejs-accumulationchart id="container" width='92%' [legendSettings]="legendSettings" [title]="title" [enableAnimation]= 'enableAnimation'>
            <e-accumulation-series-collection>
                <e-accumulation-series name='Browser' [dataSource]='pieData' xName='x' yName='y' [startAngle]="startAngle" [endAngle]="endAngle" innerRadius="20%" radius="r">
                </e-accumulation-series>
            </e-accumulation-series-collection>
    </ejs-accumulationchart>`
})
export class AppComponent implements OnInit {
    public pieData?: Object[];
    public startAngle?: number;
    public endAngle?: number;
    public center?: Object ;
    public explode?: boolean ;
    public enableAnimation?: boolean ;
    public title?: string ;
    public radius?: string ;
    public legendSettings?: Object;
    ngOnInit(): void {
    this.pieData = variespiedata;
        this.legendSettings = {
            visible: false
        };
    this.startAngle = 0;
    this.endAngle = 360;
    this.radius = 'r';
    this.enableAnimation = true;
    this.title = 'Mobile Browser Statistics';
    }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Doughnut Chart

To achieve a doughnut in pie series, customize the innerRadius property of the series. By setting value greater than 0%, a doughnut will appear. The innerRadius property takes value from 0% to 100% of the pie radius.

import { AccumulationChartModule } from '@syncfusion/ej2-angular-charts'
import { PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationAnnotationService,
  AccumulationDataLabelService } from '@syncfusion/ej2-angular-charts'


import { Component, OnInit } from '@angular/core';
import { pieData } from './datasource';
@Component({
imports: [
         AccumulationChartModule
    ],

providers: [PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationDataLabelService,
     AccumulationAnnotationService],
standalone: true,
    selector: 'app-container',
    template: `<ejs-accumulationchart id="chart-container" [legendSettings]='legendSettings'>
        <e-accumulation-series-collection>
            <e-accumulation-series [dataSource]='piedata' xName='x' yName='y' innerRadius='40%'></e-accumulation-series>
        </e-accumulation-series-collection>
    </ejs-accumulationchart>`
})
export class AppComponent implements OnInit {
    public piedata?: Object[];
    public legendSettings?: Object;
    ngOnInit(): void {
        this.piedata = pieData;
         this.legendSettings = {
            visible: false
        };
    }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Multiple Donut

You can create multiple donuts within a single chart by adding multiple series with different innerRadius values. This allows you to compare multiple data sets with the same categories. Each series can have different data, colors, and customizations. You can also use the mappingKey property in legendSettings to map the legend items based on the specified field from the data source. When set, points with matching mappingKey values are grouped into a single legend item.

import { AccumulationChartModule } from '@syncfusion/ej2-angular-charts'
import { PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationDataLabelService } from '@syncfusion/ej2-angular-charts'
import { Component, OnInit } from '@angular/core';

@Component({
imports: [AccumulationChartModule],
providers: [PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationDataLabelService],
standalone: true,
    selector: 'app-container',
    template: `<ejs-accumulationchart id="container"  title="Product Sales vs Profit Analysis" [subTitle] = 'subTitle' [tooltip]="tooltip" [legendSettings]="legendSettings"
         [border]="border" [enableBorderOnMouseMove]="false" >
        <e-accumulation-series-collection>
            <e-accumulation-series [dataSource]="totalSalesData" type="Pie" xName="x" yName="y" radius="90%"
                innerRadius="60%" [dataLabel]="outerDataLabel" tooltipMappingName='x'>
            </e-accumulation-series>
            <e-accumulation-series [dataSource]="totalProfitData" type="Pie" xName="x" yName="y" radius="50%"
                innerRadius="50%" [dataLabel]="innerDataLabel" tooltipMappingName='x'>
            </e-accumulation-series>
        </e-accumulation-series-collection>
    </ejs-accumulationchart>`
})

export class AppComponent implements OnInit {

    public subTitle: string = 'Comparing total sales revenue with profit margins by product category';

    public totalSalesData: Object[] = [
        { x: 'Electronics', y: 45000, text: '45K' },
        { x: 'Fashion', y: 32000, text: '32K' },
        { x: 'Home & Garden', y: 18000, text: '18K' },
        { x: 'Sports', y: 15000, text: '15K' },
        { x: 'Books', y: 8000, text: '8K' }
    ];

    public totalProfitData: Object[] = [
        { x: 'Electronics', y: 18000, text: '18K', profit: '40%' },
        { x: 'Fashion', y: 12800, text: '12.8K', profit: '40%' },
        { x: 'Home & Garden', y: 6300, text: '6.3K', profit: '35%' },
        { x: 'Sports', y: 4500, text: '4.5K', profit: '30%' },
        { x: 'Books', y: 2400, text: '2.4K', profit: '30%' }
    ];

    public tooltip: Object = {
        enable: true,
        format: '<b>${point.x}</b><br/>Value: <b>$${point.y}</b><br/>Percentage: <b>${point.percentage}%</b>'
    };

    public legendSettings: Object = {
        mappingKey: 'x'
    };

    public border: Object = {
        color: '#333',
        width: 2
    };

    public outerDataLabel: Object = {
        name: 'text',
        visible: true,
        position: 'Outside',
        connectorStyle: {
            type: 'Curve',
            color: 'black',
            width: 2,
            dashArray: '2,1',
            length: '5'
        }
    };

    public innerDataLabel: Object = {
        name: 'text',
        visible: true,
        position: 'Inside',
        connectorStyle: {
            type: 'Curve',
            color: 'black',
            width: 2,
            dashArray: '2,1',
            length: '5'
        }
    };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Start and End angles

You can customize the start and end angle of the pie series using the startAngle and endAngle properties. The default value of startAngle is 0 degree, and endAngle is 360 degrees. By customizing this, you can achieve a semi pie series.

import { AccumulationChartModule } from '@syncfusion/ej2-angular-charts'
import { PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationAnnotationService,
  AccumulationDataLabelService } from '@syncfusion/ej2-angular-charts'


import { Component, OnInit } from '@angular/core';
import { pieData } from './datasource';
@Component({
imports: [
         AccumulationChartModule
    ],

providers: [PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationDataLabelService,
     AccumulationAnnotationService],
standalone: true,
    selector: 'app-container',
    template: `<ejs-accumulationchart id="chart-container" [legendSettings]='legendSettings'>
        <e-accumulation-series-collection>
            <e-accumulation-series [dataSource]='piedata' xName='x' yName='y' [startAngle]='startAngle' [endAngle]='endAngle' [dataLabel]='datalabel'></e-accumulation-series>
        </e-accumulation-series-collection>
    </ejs-accumulationchart>`
})
export class AppComponent implements OnInit {
    public piedata?: Object[];
    public startAngle?: number;
    public endAngle?: number;
    public datalabel?: Object;
    public legendSettings?: Object;
    ngOnInit(): void {
        this.startAngle = 270;
        this.endAngle = 90;
        this.datalabel = { visible: true, name: 'text', position: 'Outside' };
        this.piedata = pieData;
         this.legendSettings = {
            visible: false
        };
    }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Color & Text Mapping

The fill color and the text in the data source can be mapped to the chart using pointColorMapping in series and name in datalabel respectively.

import { AccumulationChartModule } from '@syncfusion/ej2-angular-charts'
import { PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationAnnotationService,
  AccumulationDataLabelService } from '@syncfusion/ej2-angular-charts'


import { Component, OnInit } from '@angular/core';
import { dataMapping } from './datasource';
@Component({
imports: [
         AccumulationChartModule
    ],

providers: [PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationDataLabelService,
     AccumulationAnnotationService],
standalone: true,
    selector: 'app-container',
    template: `<ejs-accumulationchart id="chart-container" [legendSettings]='legendSettings'>
        <e-accumulation-series-collection>
            <e-accumulation-series [dataSource]='piedata' xName='x' yName='y' [pointColorMapping]= 'map' [dataLabel]='datalabel'></e-accumulation-series>
        </e-accumulation-series-collection>
    </ejs-accumulationchart>`
})
export class AppComponent implements OnInit {
    public piedata?: Object[];
    public map: Object = 'fill';
    public datalabel?: Object;
    public legendSettings?: Object;
    ngOnInit(): void {
        this.piedata = dataMapping;
        this.datalabel = { visible: true, name: 'text', position: 'Outside' };
        this.legendSettings = {
            visible: false
        };
    }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Border Radius

You can create rounded corners for each slice by using the borderRadius option, which gives the chart a modern and polished appearance.

import { AccumulationChartModule } from '@syncfusion/ej2-angular-charts'
import { PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationAnnotationService,
  AccumulationDataLabelService } from '@syncfusion/ej2-angular-charts'


import { Component, OnInit } from '@angular/core';
import { variespiedata } from './datasource';
@Component({
imports: [
         AccumulationChartModule
    ],

providers: [PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationDataLabelService,
     AccumulationAnnotationService],
standalone: true,
    selector: 'app-container',
    template: `<ejs-accumulationchart id="container" width='92%' [legendSettings]="legendSettings" [title]="title" [enableAnimation]= 'enableAnimation'>
            <e-accumulation-series-collection>
                <e-accumulation-series name='Browser' [dataSource]='pieData' xName='x' yName='y' [startAngle]="startAngle" [endAngle]="endAngle" innerRadius="60%" borderRadius='8'>
                </e-accumulation-series>
            </e-accumulation-series-collection>
    </ejs-accumulationchart>`
})
export class AppComponent implements OnInit {
    public pieData?: Object[];
    public startAngle?: number;
    public endAngle?: number;
    public center?: Object ;
    public explode?: boolean ;
    public enableAnimation?: boolean ;
    public title?: string ;
    public radius?: string ;
    public legendSettings?: Object;
    ngOnInit(): void {
    this.pieData = variespiedata;
        this.legendSettings = {
            visible: false
        };
    this.startAngle = 0;
    this.endAngle = 360;
    this.enableAnimation = true;
    this.title = 'Mobile Browser Statistics';
    }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Hide pie or doughnut border

By default, the border will appear in the pie/doughnut chart while mouse hover on the chart. You can disable the the border by setting enableBorderOnMouseMove property is false.

import { AccumulationChartModule } from '@syncfusion/ej2-angular-charts'
import { PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationAnnotationService,
  AccumulationDataLabelService } from '@syncfusion/ej2-angular-charts'


import { Component, OnInit } from '@angular/core';
import { dataMapping } from './datasource';
@Component({
imports: [
         AccumulationChartModule
    ],

providers: [PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationDataLabelService,
     AccumulationAnnotationService],
standalone: true,
    selector: 'app-container',
    template: `<ejs-accumulationchart id="chart-container" [legendSettings]='legendSettings' [enableBorderOnMouseMove]='enableBorderOnMouseMove'>
        <e-accumulation-series-collection>
            <e-accumulation-series [dataSource]='piedata' xName='x' yName='y' [dataLabel]='datalabel'></e-accumulation-series>
        </e-accumulation-series-collection>
    </ejs-accumulationchart>`
})
export class AppComponent implements OnInit {
    public piedata?: Object[];
    public datalabel?: Object;
    public legendSettings?: Object;
    public enableBorderOnMouseMove?: boolean;
    ngOnInit(): void {
        this.enableBorderOnMouseMove = false;
        this.piedata = dataMapping;
        this.datalabel = { visible: true, name: 'text', position: 'Outside' };
        this.legendSettings = {
            visible: false
        };
    }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Patterns

You can apply different patterns to the pie slices using the applyPattern property in the series and the pointRender event.

import { AccumulationChartModule } from '@syncfusion/ej2-angular-charts'
import { PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationAnnotationService,
  AccumulationDataLabelService } from '@syncfusion/ej2-angular-charts'


import { Component, OnInit } from '@angular/core';
import { variespiedata } from './datasource';
@Component({
imports: [
         AccumulationChartModule
    ],

providers: [PieSeriesService, AccumulationLegendService, AccumulationTooltipService, AccumulationDataLabelService,
     AccumulationAnnotationService],
standalone: true,
    selector: 'app-container',
    template: `<ejs-accumulationchart id="container" width='92%' [legendSettings]="legendSettings" [title]="title" [enableAnimation]= 'enableAnimation'>
            <e-accumulation-series-collection>
                <e-accumulation-series name='Browser' [dataSource]='pieData' xName='x' yName='y' [startAngle]="startAngle" applyPattern='true' [endAngle]="endAngle">
                </e-accumulation-series>
            </e-accumulation-series-collection>
    </ejs-accumulationchart>`
})
export class AppComponent implements OnInit {
    public pieData?: Object[];
    public startAngle?: number;
    public endAngle?: number;
    public center?: Object ;
    public explode?: boolean ;
    public enableAnimation?: boolean ;
    public title?: string ;
    public radius?: string ;
    public legendSettings?: Object;
    ngOnInit(): void {
    this.pieData = variespiedata;
        this.legendSettings = {
            visible: false
        };
    this.startAngle = 0;
    this.endAngle = 360;
    this.enableAnimation = true;
    this.title = 'Mobile Browser Statistics';
    }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Multi-level pie chart

You can achieve a multi-level drill down in pie and doughnut charts using pointClick event. If user clicks any point in the chart, that corresponding data will be shown in the next level and so on based on point clicked.

You can also achieve drill-up (back to the initial state) by using chartMouseClick event. In below sample, you can drill-up by clicking back button in the center of the chart.

import { ChartModule } from '@syncfusion/ej2-angular-charts'
import { GridModule } from '@syncfusion/ej2-angular-grids'
import { PageService, SortService, FilterService, GroupService } from '@syncfusion/ej2-angular-grids'
import { AccumulationChartModule } from '@syncfusion/ej2-angular-charts'
import { PieSeriesService, AccumulationTooltipService, AccumulationDataLabelService } from '@syncfusion/ej2-angular-charts'
import { LineSeriesService, DateTimeService, DataLabelService, StackingColumnSeriesService, CategoryService, ChartShape,
       StepAreaSeriesService,SplineSeriesService, ChartAnnotationService, LegendService, TooltipService, StripLineService,
       SelectionService,ScatterSeriesService
    } from '@syncfusion/ej2-angular-charts'


import { Component, ViewChild } from '@angular/core';
import {
  AccumulationChartComponent,
  IMouseEventArgs,
  IAccTextRenderEventArgs,
  AccumulationChart,
} from '@syncfusion/ej2-angular-charts';
import { GridComponent } from '@syncfusion/ej2-angular-grids';
import { getElement } from '@syncfusion/ej2-charts';

/**
 * Sample for Drilldown in Pie chart
 */
@Component({
imports: [
         ChartModule, AccumulationChartModule, GridModule
    ],

providers: [ LineSeriesService, DateTimeService, DataLabelService, StackingColumnSeriesService,CategoryService,
               StepAreaSeriesService, SplineSeriesService, ChartAnnotationService, LegendService, TooltipService, StripLineService,
               PieSeriesService, AccumulationTooltipService, AccumulationDataLabelService, SelectionService,ScatterSeriesService
               ,PageService],
standalone: true,
  selector: 'app-container',
  template: `<ejs-accumulationchart id="container" #pie style='display:block; width: 92%' [legendSettings]="legendSettings"
            [enableSmartLabels]='false' [title]="title" (textRender)="onTextRender($event)"
            (chartMouseClick)="onChartMouseClick($event)" (pointClick)="onPointClick($event)">
            <e-accumulation-series-collection>
                <e-accumulation-series [dataSource]='data' xName='x' yName='y' [startAngle]="startAngle"
                    [endAngle]="endAngle" innerRadius="0%" radius="70%" [dataLabel]="dataLabel" [explode]="explode"
                    explodeOffset='10%' [explodeIndex]='explodeIndex'>
                </e-accumulation-series>
            </e-accumulation-series-collection>
        </ejs-accumulationchart>

        <ejs-grid id='Grid' #grid [dataSource]='data'>
            <e-columns>
                <e-column field='x' headerText='Vehicle' type='string'></e-column>
                <e-column field='y' headerText='Sales' type='string'></e-column>
            </e-columns>
        </ejs-grid>`,
})
export class AppComponent {
  public data = [
    {
      x: 'SUV',
      y: 25,
      z: [
        {
          title: 'Automobile Sales in the SUV Segment',
          x: 'Toyota',
          y: 8,
          z: [
            { x: '2000', y: 20 },
            { x: '2001', y: 30 },
            { x: '2002', y: 40 },
          ],
        },
        { x: 'Ford', y: 12 },
        { x: 'GM', y: 17 },
        { x: 'Renault', y: 6 },
      ],
    },
    {
      x: 'Car',
      y: 37,
      z: [
        { title: 'Automobile Sales in the Car Segment', x: 'Toyota', y: 7 },
        { x: 'Chrysler', y: 12 },
        { x: 'Nissan', y: 9 },
        { x: 'Ford', y: 15 },
      ],
    },
    {
      x: 'Pickup',
      y: 15,
      z: [
        { title: 'Automobile Sales in the Pickup Segment', x: 'Nissan', y: 9 },
        { x: 'Chrysler', y: 4 },
        { x: 'Ford', y: 7 },
        { x: 'Toyota', y: 20 },
      ],
    },
    {
      x: 'Minivan',
      y: 23,
      z: [
        {
          title: 'Automobile Sales in the Minivan Segment',
          x: 'Hummer',
          y: 11,
        },
        { x: 'Ford', y: 5 },
        { x: 'GM', y: 12 },
        { x: 'Chrysler', y: 3 },
      ],
    },
  ];

  @ViewChild('pie')
  public pie?: AccumulationChartComponent | AccumulationChart;

  @ViewChild('grid')
  public grid?: GridComponent;

  public pointIndex: number = -1;
  //Initializing Legend
  public legendSettings: Object = {
    visible: false,
  };
  //Initializing Datalabel
  public dataLabel: Object = {
    visible: true,
    position: 'Inside',
    connectorStyle: { type: 'Curve', length: '5%' },
    font: { size: '14px', color: 'white' },
  };
  public explode: boolean = false;
  public content: string =
    '<div id="back" style="cursor:pointer;padding:3px;width:30px; height:30px;">' +
          '<img src="https://ej2.syncfusion.com/javascript/demos/src/chart/images/back.png" id="back" />';
  public startAngle: number = 0;
  public explodeIndex: number = 2;
  public endAngle: number = 360;
  public title: string = 'Automobile Sales by Category';
  public isparent: boolean = true;
  public onTextRender(args: IAccTextRenderEventArgs): void {
    args.text = args.point.x + ' ' + args.point.y + ' %';
  }
  public onChartMouseClick(args: IMouseEventArgs): void {
    if (args.target.indexOf('back') > -1) {
      if (this.pie?.series[0].name === 'Level 3') {
        this.pie.series[0].dataSource = this.data[this.pointIndex].z;
        this.pie.series[0].name = 'Level 2';
        this.pie.title = this.data[this.pointIndex].z[0].title as any;
        this.pie.series[0].innerRadius = '30%';
        (this.grid as GridComponent ).dataSource = this.pie.series[0].dataSource;
        ((this.grid as GridComponent ).columns[0] as any).headerText = this.data[this.pointIndex].x;
        (this.grid as GridComponent ).refresh();
        this.pie.refresh();
      } else if (this.pie?.series[0].name === 'Level 2') {
        this.pie.series[0].dataSource = this.data;
        this.pie.series[0].name = 'Level 1';
        this.pie.series[0].innerRadius = '0%';
        this.pie.title = 'Automobile Sales by Category';
        this.pie.annotations = null as any;
        this.pie.pointClick = this.onPointClick;
        (this.grid as GridComponent ).dataSource = this.pie.series[0].dataSource;
        ((this.grid as GridComponent ).columns[0] as any).headerText = 'Vehicle';
        (this.grid as GridComponent ).refresh();
        this.pie.refresh();
      }
    }
    (this.grid as GridComponent ).dataSource = this.pie?.series[0].dataSource as any;
  }
  public click(args: IMouseEventArgs | any) {
    if (this.pie?.series[0].name !== 'Level 3') {
      switch (args.pointIndex) {
        case 0:
          this.pie!.series[0].dataSource = (this.data[0].z[0] as any).z;
          this.pie!.title = 'SUV Sales by Years';
          this.pie!.series[0].name = 'Level 3';
          ((this.grid as GridComponent ).columns[0] as any).headerText = 'Year';
          (this.grid as GridComponent ).refresh();
          this.pie?.refresh();
          break;
      }
      (this.grid as GridComponent ).dataSource = this.pie?.series[0].dataSource as any;
    }
  }
  public onPointClick(args: IMouseEventArgs | any) {
    if (
      getElement(
        this.pie?.element.id +
          '_Series_' +
          args.seriesIndex +
          '_Point_' +
          args.pointIndex
      )
    ) {
      this.pie!.series[0].dataSource = this.data[args.pointIndex].z;
      this.pie!.title = this.data[args.pointIndex].z[0].title as any;
      this.pointIndex = args.pointIndex;

      this.pie!.series[0].name = 'Level 2';
      this.pie!.series[0].innerRadius = '30%';
      this.pie!.annotations = [
        {
          content:
            '<div id="back" style="cursor:pointer;padding:3px;width:30px; height:30px;">' +
            '<img src="https://ej2.syncfusion.com/javascript/demos/src/chart/images/back.png" id="back" />',
          region: 'Series',
          x: '50%',
          y: '50%',
        },
      ];
    }
    (this.grid as GridComponent ).dataSource = this.pie?.series[0].dataSource as any;
    ((this.grid as GridComponent ).columns[0] as any).headerText = this.data[args.pointIndex].x;
    (this.grid as GridComponent ).refresh();
    this.pie?.refresh();
  }
  constructor() {
    //code
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Pie dough nut in Vue Accumulation chart component

18 Nov 201824 minutes to read

Pie Chart

To render a pie series, use the series type as Pie and inject the PieSeries module into the provide. If the PieSeries module is not injected, this module will be loaded by default.

<template>
  <div id="app">
    <ejs-accumulationchart id="container">
      <e-accumulation-series-collection>
        <e-accumulation-series :dataSource='seriesData' xName='x' yName='y'> </e-accumulation-series>
      </e-accumulation-series-collection>
    </ejs-accumulationchart>
  </div>
</template>
<script setup>
import { provide } from "vue";
import { AccumulationChartComponent as EjsAccumulationchart, AccumulationSeriesCollectionDirective as EAccumulationSeriesCollection, AccumulationSeriesDirective as EAccumulationSeries, PieSeries } from "@syncfusion/ej2-vue-charts";


const seriesData = [
  { x: 'Jan', y: 3, fill: '#498fff', text: 'January' }, { x: 'Feb', y: 3.5, fill: '#ffa060', text: 'February' },
  { x: 'Mar', y: 7, fill: '#ff68b6', text: 'March' }, { x: 'Apr', y: 13.5, fill: '#81e2a1', text: 'April' }
];

provide('accumulationchart', [PieSeries]);

</script>
<style>
#container {
  height: 350px;
}
</style>
<template>
  <div id="app">
    <ejs-accumulationchart id="container">
      <e-accumulation-series-collection>
        <e-accumulation-series :dataSource='seriesData' xName='x' yName='y'> </e-accumulation-series>
      </e-accumulation-series-collection>
    </ejs-accumulationchart>
  </div>
</template>
<script>

import { AccumulationChartComponent, AccumulationSeriesCollectionDirective, AccumulationSeriesDirective, PieSeries } from "@syncfusion/ej2-vue-charts";

export default {
  name: "App",
  components: {
    'ejs-accumulationchart': AccumulationChartComponent,
    'e-accumulation-series-collection': AccumulationSeriesCollectionDirective,
    'e-accumulation-series': AccumulationSeriesDirective
  },
  data() {
    return {
      seriesData: [
        { x: 'Jan', y: 3, fill: '#498fff', text: 'January' }, { x: 'Feb', y: 3.5, fill: '#ffa060', text: 'February' },
        { x: 'Mar', y: 7, fill: '#ff68b6', text: 'March' }, { x: 'Apr', y: 13.5, fill: '#81e2a1', text: 'April' }
      ]
    };
  },
  provide: {
    accumulationchart: [PieSeries]
  }
};
</script>
<style>
#container {
  height: 350px;
}
</style>

Radius Customization

By default, radius of the pie series will be 80% of the size (minimum of chart width and height).

You can customize this using radius property of the series.

<template>
  <div id="app">
    <ejs-accumulationchart id="container">
      <e-accumulation-series-collection>
        <e-accumulation-series :dataSource='seriesData' xName='x' yName='y' radius='90%'> </e-accumulation-series>
      </e-accumulation-series-collection>
    </ejs-accumulationchart>
  </div>
</template>
<script setup>
import { provide } from "vue";
import { AccumulationChartComponent as EjsAccumulationchart, AccumulationSeriesCollectionDirective as EAccumulationSeriesCollection, AccumulationSeriesDirective as EAccumulationSeries, PieSeries } from "@syncfusion/ej2-vue-charts";

const seriesData = [
  { x: 'Jan', y: 3, fill: '#498fff', text: 'January' }, { x: 'Feb', y: 3.5, fill: '#ffa060', text: 'February' },
  { x: 'Mar', y: 7, fill: '#ff68b6', text: 'March' }, { x: 'Apr', y: 13.5, fill: '#81e2a1', text: 'April' }
];

provide('accumulationchart', [PieSeries]);

</script>
<style>
#container {
  height: 350px;
}
</style>
<template>
    <div id="app">
         <ejs-accumulationchart id="container">
            <e-accumulation-series-collection>
                <e-accumulation-series :dataSource='seriesData' xName='x' yName='y' radius='90%'> </e-accumulation-series>
            </e-accumulation-series-collection>
        </ejs-accumulationchart>
    </div>
</template>
<script>

import {  AccumulationChartComponent, AccumulationSeriesCollectionDirective, AccumulationSeriesDirective, PieSeries } from "@syncfusion/ej2-vue-charts";

export default {
name: "App",
components: {
    'ejs-accumulationchart': AccumulationChartComponent,
    'e-accumulation-series-collection': AccumulationSeriesCollectionDirective,
    'e-accumulation-series': AccumulationSeriesDirective
  },
  data() {
    return {
      seriesData: [
           { x: 'Jan', y: 3, fill: '#498fff', text:'January' }, { x: 'Feb', y: 3.5, fill: '#ffa060', text: 'February' },
           { x: 'Mar', y: 7, fill: '#ff68b6', text: 'March' }, { x: 'Apr', y: 13.5, fill: '#81e2a1', text: 'April' }
            ]
    };
  },
  provide: {
     accumulationchart: [PieSeries]
  }
};
</script>
<style>
 #container {
     height: 350px;
 }
</style>

Pie Center

The center position of the pie can be changed by Center X and Center Y. By default, center value of the pie series x and y is 50%. You can customize this using center property of the series.

<template>
  <div id="app">
    <ejs-accumulationchart id='chartcontainer' :title='title' :legendSettings='legendSettings' :tooltip='tooltip'
      enableSmartLables='true' :enableAnimation='enableAnimation' :center='center'>
      <e-accumulation-series-collection>
        <e-accumulation-series :dataSource='seriesData' :startAngle='startAngle' :endAngle='endAngle' :radius='radius'
          xName='x' yName='y' :dataLabel='dataLabel' name='Browser' innerRadius='0%'> </e-accumulation-series>
      </e-accumulation-series-collection>
    </ejs-accumulationchart>
  </div>
</template>
<script setup>
import { provide } from "vue";
import { AccumulationChartComponent as EjsAccumulationchart, AccumulationSeriesCollectionDirective as EAccumulationSeriesCollection, AccumulationSeriesDirective as EAccumulationSeries, PieSeries, AccumulationDataLabel } from "@syncfusion/ej2-vue-charts";


const seriesData = [
  { 'x': 'Chrome', y: 37, text: '37%' }, { 'x': 'UC Browser', y: 17, text: '17%' },
  { 'x': 'iPhone', y: 19, text: '19%' },
  { 'x': 'Others', y: 4, text: '4%' }, { 'x': 'Opera', y: 11, text: '11%' },
  { 'x': 'Android', y: 12, text: '12%' }
];
const dataLabel = {
  visible: true,
  position: 'Inside', name: 'text',
  font: {
    fontWeight: '600'
  }
}
const enableAnimation = false;
const legendSettings = {
  visible: false,
};
const tooltip = { enable: false, format: '${point.x} : <b>${point.y}%</b>' };
const startAngle = '0';
const endAngle = '360';
const radius = '70%';
const center = { x: '50%', y: '50%' };
const title = "Mobile Browser Statistics";

provide('accumulationchart', [PieSeries, AccumulationDataLabel]);

</script>
<style>
#container {
  height: 350px;
}
</style>
<template>
  <div id="app">
    <ejs-accumulationchart id='chartcontainer' :title='title' :legendSettings='legendSettings' :tooltip='tooltip'
      enableSmartLables='true' :enableAnimation='enableAnimation' :center='center'>
      <e-accumulation-series-collection>
        <e-accumulation-series :dataSource='seriesData' :startAngle='startAngle' :endAngle='endAngle' :radius='radius'
          xName='x' yName='y' :dataLabel='dataLabel' name='Browser' innerRadius='0%'> </e-accumulation-series>
      </e-accumulation-series-collection>
    </ejs-accumulationchart>
  </div>
</template>
<script>

import { AccumulationChartComponent, AccumulationSeriesCollectionDirective, AccumulationSeriesDirective, PieSeries, AccumulationDataLabel } from "@syncfusion/ej2-vue-charts";

export default {
  name: "App",
  components: {
    'ejs-accumulationchart': AccumulationChartComponent,
    'e-accumulation-series-collection': AccumulationSeriesCollectionDirective,
    'e-accumulation-series': AccumulationSeriesDirective
  },
  data() {
    return {
      seriesData: [
        { 'x': 'Chrome', y: 37, text: '37%' }, { 'x': 'UC Browser', y: 17, text: '17%' },
        { 'x': 'iPhone', y: 19, text: '19%' },
        { 'x': 'Others', y: 4, text: '4%' }, { 'x': 'Opera', y: 11, text: '11%' },
        { 'x': 'Android', y: 12, text: '12%' }
      ],
      dataLabel: {
        visible: true,
        position: 'Inside', name: 'text',
        font: {
          fontWeight: '600'
        }
      },
      enableAnimation: false,
      legendSettings: {
        visible: false,
      },
      tooltip: { enable: false, format: '${point.x} : <b>${point.y}%</b>' },
      startAngle: '0',
      endAngle: '360',
      radius: '70%',
      center: { x: '50%', y: '50%' },
      title: "Mobile Browser Statistics"
    };
  },
  provide: {
    accumulationchart: [PieSeries, AccumulationDataLabel]
  }
};
</script>
<style>
#container {
  height: 350px;
}
</style>

Various Radius Pie Chart

You can use radius mapping to render the slice with different radius pie and also use border , fill properties to customize the point. dataLabel is used to represent individual data and its value.

<template>
  <div id="app">
    <ejs-accumulationchart id="container" ref="pie" style='display:block;' :legendSettings="legendSettings"
      :tooltip="tooltip" :enableAnimation='enableAnimation' :enableSmartLabels='enableSmartLabels'>
      <e-accumulation-series-collection>
        <e-accumulation-series :dataSource='data' xName='x' yName='y' :radius='radius' innerRadius="20%"
          :dataLabel="dataLabel"> </e-accumulation-series>
      </e-accumulation-series-collection>
    </ejs-accumulationchart>
  </div>
</template>
<script setup>
import { provide } from "vue";
import { AccumulationChartComponent as EjsAccumulationchart, AccumulationSeriesCollectionDirective as EAccumulationSeriesCollection, AccumulationSeriesDirective as EAccumulationSeries, AccumulationDataLabel, PieSeries } from "@syncfusion/ej2-vue-charts";

const data = [
  { x: 'Argentina', y: 505370, r: '100' },
  { x: 'Belgium', y: 551500, r: '118.7' },
  { x: 'Cuba', y: 312685, r: '124.6' },
  { x: 'Dominican Republic', y: 350000, r: '137.5' },
  { x: 'Egypt', y: 301000, r: '150.8' },
  { x: 'Kazakhstan', y: 300000, r: '155.5' },
  { x: 'Somalia', y: 357022, r: '160.6' }
];
const radius = 'r';
const legendSettings = { visible: true };
const dataLabel = { visible: true, position: 'Outside', name: 'x' };
const tooltip = {
  enable: true, header: '<b>${point.x}</b>', format: 'Composition: <b>${point.y}</b>'
};
const enableAnimation = true;
const enableSmartLabels = true;

provide('accumulationchart', [PieSeries, AccumulationDataLabel]);

</script>
<style>
#container {
  height: 350px;
}
</style>
<template>
  <div id="app">
    <ejs-accumulationchart id="container" ref="pie" style='display:block;' :legendSettings="legendSettings"
      :tooltip="tooltip" :enableAnimation='enableAnimation' :enableSmartLabels='enableSmartLabels'>
      <e-accumulation-series-collection>
        <e-accumulation-series :dataSource='data' xName='x' yName='y' :radius='radius' innerRadius="20%"
          :dataLabel="dataLabel"> </e-accumulation-series>
      </e-accumulation-series-collection>
    </ejs-accumulationchart>
  </div>
</template>
<script>

import { AccumulationChartComponent, AccumulationSeriesCollectionDirective, AccumulationSeriesDirective, AccumulationDataLabel, PieSeries } from "@syncfusion/ej2-vue-charts";

export default {
  name: "App",
  components: {
    'ejs-accumulationchart': AccumulationChartComponent,
    'e-accumulation-series-collection': AccumulationSeriesCollectionDirective,
    'e-accumulation-series': AccumulationSeriesDirective
  },
  data() {
    return {
      data: [
        { x: 'Argentina', y: 505370, r: '100' },
        { x: 'Belgium', y: 551500, r: '118.7' },
        { x: 'Cuba', y: 312685, r: '124.6' },
        { x: 'Dominican Republic', y: 350000, r: '137.5' },
        { x: 'Egypt', y: 301000, r: '150.8' },
        { x: 'Kazakhstan', y: 300000, r: '155.5' },
        { x: 'Somalia', y: 357022, r: '160.6' }
      ],
      radius: 'r',
      legendSettings: { visible: true },
      dataLabel: { visible: true, position: 'Outside', name: 'x' },
      tooltip: {
        enable: true, header: '<b>${point.x}</b>', format: 'Composition: <b>${point.y}</b>'
      },
      enableAnimation: true,
      enableSmartLabels: true
    };
  },
  provide: {
    accumulationchart: [PieSeries, AccumulationDataLabel]
  }
};
</script>
<style>
#container {
  height: 350px;
}
</style>

Doughnut Chart

To achieve a doughnut in pie series, customize the innerRadius property of the series. By setting value greater than 0%, a doughnut will appear. The innerRadius property takes value from 0% to 100% of the pie radius.

<template>
    <div id="app">
        <ejs-accumulationchart id="container">
            <e-accumulation-series-collection>
                <e-accumulation-series :dataSource='seriesData' xName='x' yName='y' innerRadius='40%'>
                </e-accumulation-series>
            </e-accumulation-series-collection>
        </ejs-accumulationchart>
    </div>
</template>
<script setup>
import { provide } from "vue";
import { AccumulationChartComponent as EjsAccumulationchart, AccumulationSeriesCollectionDirective as EAccumulationSeriesCollection, AccumulationSeriesDirective as EAccumulationSeries, PieSeries } from "@syncfusion/ej2-vue-charts";

const seriesData = [
    { x: 'Jan', y: 3, fill: '#498fff', text: 'January' }, { x: 'Feb', y: 3.5, fill: '#ffa060', text: 'February' },
    { x: 'Mar', y: 7, fill: '#ff68b6', text: 'March' }, { x: 'Apr', y: 13.5, fill: '#81e2a1', text: 'April' }
];

provide('accumulationchart', [PieSeries]);

</script>
<style>
#container {
    height: 350px;
}
</style>
<template>
    <div id="app">
        <ejs-accumulationchart id="container">
            <e-accumulation-series-collection>
                <e-accumulation-series :dataSource='seriesData' xName='x' yName='y' innerRadius='40%'>
                </e-accumulation-series>
            </e-accumulation-series-collection>
        </ejs-accumulationchart>
    </div>
</template>
<script>

import { AccumulationChartComponent, AccumulationSeriesCollectionDirective, AccumulationSeriesDirective, PieSeries } from "@syncfusion/ej2-vue-charts";

export default {
    name: "App",
    components: {
        'ejs-accumulationchart': AccumulationChartComponent,
        'e-accumulation-series-collection': AccumulationSeriesCollectionDirective,
        'e-accumulation-series': AccumulationSeriesDirective
    },
    data() {
        return {
            seriesData: [
                { x: 'Jan', y: 3, fill: '#498fff', text: 'January' }, { x: 'Feb', y: 3.5, fill: '#ffa060', text: 'February' },
                { x: 'Mar', y: 7, fill: '#ff68b6', text: 'March' }, { x: 'Apr', y: 13.5, fill: '#81e2a1', text: 'April' }
            ]
        };
    },
    provide: {
        accumulationchart: [PieSeries]
    }
};
</script>
<style>
#container {
    height: 350px;
}
</style>

Multiple Donut

You can create multiple donuts within a single chart by adding multiple series with different innerRadius values. This allows you to compare multiple data sets with the same categories. Each series can have different data, colors, and customizations. You can also use the mappingKey property in legendSettings to map the legend items based on the specified field from the data source. When set, points with matching mappingKey values are grouped into a single legend item.

<template>
  <div id="app">
    <ejs-accumulationchart
      id="container"
      :title="title"
      :subTitle="subTitle"
      :tooltip="tooltip"
      :legendSettings="legendSettings"
      :border="border"
      :enableBorderOnMouseMove="false">

      <e-accumulation-series-collection>

        <!-- Outer Donut: Total Sales -->
        <e-accumulation-series
          :dataSource="totalSalesData"
          type="Pie"
          xName="x"
          yName="y"
          radius="90%"
          innerRadius="60%"
          name="Total Sales"
          :dataLabel="outerDataLabel"
          tooltipMappingName="x">
        </e-accumulation-series>

        <!-- Inner Donut: Total Profit -->
        <e-accumulation-series
          :dataSource="totalProfitData"
          type="Pie"
          xName="x"
          yName="y"
          radius="50%"
          innerRadius="50%"
          name="Total Profit"
          :dataLabel="innerDataLabel"
          tooltipMappingName="x">
        </e-accumulation-series>

      </e-accumulation-series-collection>
    </ejs-accumulationchart>
  </div>
</template>

<script setup>
import { provide } from "vue";
import { AccumulationChartComponent as EjsAccumulationchart, AccumulationSeriesCollectionDirective as EAccumulationSeriesCollection, AccumulationSeriesDirective as EAccumulationSeries, PieSeries, AccumulationLegend, AccumulationDataLabel, AccumulationTooltip } from "@syncfusion/ej2-vue-charts";

const title = 'Product Sales vs Profit Analysis';

const subTitle =
  'Comparing total sales revenue with profit margins by product category';

const totalSalesData = [
  { x: 'Electronics', y: 45000, text: '45K' },
  { x: 'Fashion', y: 32000, text: '32K' },
  { x: 'Home & Garden', y: 18000, text: '18K' },
  { x: 'Sports', y: 15000, text: '15K' },
  { x: 'Books', y: 8000, text: '8K' }
];

const totalProfitData = [
  { x: 'Electronics', y: 18000, text: '18K', profit: '40%' },
  { x: 'Fashion', y: 12800, text: '12.8K', profit: '40%' },
  { x: 'Home & Garden', y: 6300, text: '6.3K', profit: '35%' },
  { x: 'Sports', y: 4500, text: '4.5K', profit: '30%' },
  { x: 'Books', y: 2400, text: '2.4K', profit: '30%' }
];

const tooltip = {
  enable: true,
  format:
    '<b>${point.x}</b><br/>Value: <b>$${point.y}</b><br/>Percentage: <b>${point.percentage}%</b>'
};

const legendSettings = {
  mappingKey: 'x'
};

const border = {
  color: '#333',
  width: 2
};

const outerDataLabel = {
  name: 'text',
  visible: true,
  position: 'Outside',
  connectorStyle: {
    type: 'Curve',
    color: 'black',
    width: 2,
    dashArray: '2,1',
    length: '5'
  }
};

const innerDataLabel = {
  name: 'text',
  visible: true,
  position: 'Inside',
  connectorStyle: {
    type: 'Curve',
    color: 'black',
    width: 2,
    dashArray: '2,1',
    length: '5'
  }
}

provide('accumulationchart', [PieSeries, AccumulationLegend, AccumulationDataLabel, AccumulationTooltip]);
</script>
<style>
  #container {
    height: 350px;
  }
</style>
<template>
  <div id="app">
    <ejs-accumulationchart
      id="container"
      :title="title"
      :subTitle="subTitle"
      :tooltip="tooltip"
      :legendSettings="legendSettings"
      :border="border"
      :enableBorderOnMouseMove="false">

      <e-accumulation-series-collection>

        <!-- Outer Donut: Total Sales -->
        <e-accumulation-series
          :dataSource="totalSalesData"
          type="Pie"
          xName="x"
          yName="y"
          radius="90%"
          innerRadius="60%"
          name="Total Sales"
          :dataLabel="outerDataLabel"
          tooltipMappingName="x">
        </e-accumulation-series>

        <!-- Inner Donut: Total Profit -->
        <e-accumulation-series
          :dataSource="totalProfitData"
          type="Pie"
          xName="x"
          yName="y"
          radius="50%"
          innerRadius="50%"
          name="Total Profit"
          :dataLabel="innerDataLabel"
          tooltipMappingName="x">
        </e-accumulation-series>

      </e-accumulation-series-collection>
    </ejs-accumulationchart>
  </div>
</template>
<script>

import { AccumulationChartComponent, AccumulationSeriesCollectionDirective, AccumulationSeriesDirective, PieSeries, AccumulationLegend, AccumulationDataLabel, AccumulationTooltip } from "@syncfusion/ej2-vue-charts";

export default {
  name: "App",
  components: {
    'ejs-accumulationchart': AccumulationChartComponent,
    'e-accumulation-series-collection': AccumulationSeriesCollectionDirective,
    'e-accumulation-series': AccumulationSeriesDirective
  },
  data() {
    return {
      title: 'Product Sales vs Profit Analysis',
      subTitle: 'Comparing total sales revenue with profit margins by product category',
      totalSalesData: [
        { x: 'Electronics', y: 45000, text: '45K' },
        { x: 'Fashion', y: 32000, text: '32K' },
        { x: 'Home & Garden', y: 18000, text: '18K' },
        { x: 'Sports', y: 15000, text: '15K' },
        { x: 'Books', y: 8000, text: '8K' }
      ],
      totalProfitData: [
        { x: 'Electronics', y: 18000, text: '18K', profit: '40%' },
        { x: 'Fashion', y: 12800, text: '12.8K', profit: '40%' },
        { x: 'Home & Garden', y: 6300, text: '6.3K', profit: '35%' },
        { x: 'Sports', y: 4500, text: '4.5K', profit: '30%' },
        { x: 'Books', y: 2400, text: '2.4K', profit: '30%' }
      ],
      tooltip: {
        enable: true,
        format:
          '<b>${point.x}</b><br/>Value: <b>$${point.y}</b><br/>Percentage: <b>${point.percentage}%</b>'
      },
      legendSettings: {
        mappingKey: 'x'
      },
      border: {
        color: '#333',
        width: 2
      },
      outerDataLabel: {
        name: 'text',
        visible: true,
        position: 'Outside',
        connectorStyle: {
          type: 'Curve',
          color: 'black',
          width: 2,
          dashArray: '2,1',
          length: '5'
        }
      },
      innerDataLabel: {
        name: 'text',
        visible: true,
        position: 'Inside',
        connectorStyle: {
          type: 'Curve',
          color: 'black',
          width: 2,
          dashArray: '2,1',
          length: '5'
        }
      }
    };
  },
  provide: {
    accumulationchart: [PieSeries, AccumulationLegend, AccumulationDataLabel, AccumulationTooltip]
  },
};
</script>
<style>
  #container {
    height: 350px;
  }
</style>

Start and End angles

You can customize the start and end angle of the pie series using the startAngle and endAngle properties. The default value of startAngle is 0 degree, and endAngle is 360 degrees. By customizing this, you can achieve a semi pie series.

<template>
    <div id="app">
        <ejs-accumulationchart id="container">
            <e-accumulation-series-collection>
                <e-accumulation-series :dataSource='seriesData' xName='x' yName='y' startAngle=270 endAngle=90>
                </e-accumulation-series>
            </e-accumulation-series-collection>
        </ejs-accumulationchart>
    </div>
</template>
<script setup>
import { provide } from "vue";
import { AccumulationChartComponent as EjsAccumulationchart, AccumulationSeriesCollectionDirective as EAccumulationSeriesCollection, AccumulationSeriesDirective as EAccumulationSeries, PieSeries } from "@syncfusion/ej2-vue-charts";

const seriesData = [
    { x: 'Jan', y: 3, fill: '#498fff', text: 'January' }, { x: 'Feb', y: 3.5, fill: '#ffa060', text: 'February' },
    { x: 'Mar', y: 7, fill: '#ff68b6', text: 'March' }, { x: 'Apr', y: 13.5, fill: '#81e2a1', text: 'April' }
];

provide('accumulationchart', [PieSeries]);

</script>
<style>
#container {
    height: 350px;
}
</style>
<template>
    <div id="app">
        <ejs-accumulationchart id="container">
            <e-accumulation-series-collection>
                <e-accumulation-series :dataSource='seriesData' xName='x' yName='y' startAngle=270 endAngle=90>
                </e-accumulation-series>
            </e-accumulation-series-collection>
        </ejs-accumulationchart>
    </div>
</template>
<script>

import { AccumulationChartComponent, AccumulationSeriesCollectionDirective, AccumulationSeriesDirective, PieSeries } from "@syncfusion/ej2-vue-charts";


export default {
    name: "App",
    components: {
        'ejs-accumulationchart': AccumulationChartComponent,
        'e-accumulation-series-collection': AccumulationSeriesCollectionDirective,
        'e-accumulation-series': AccumulationSeriesDirective
    },
    data() {
        return {
            seriesData: [
                { x: 'Jan', y: 3, fill: '#498fff', text: 'January' }, { x: 'Feb', y: 3.5, fill: '#ffa060', text: 'February' },
                { x: 'Mar', y: 7, fill: '#ff68b6', text: 'March' }, { x: 'Apr', y: 13.5, fill: '#81e2a1', text: 'April' }
            ]
        };
    },
    provide: {
        accumulationchart: [PieSeries]
    }
};
</script>
<style>
#container {
    height: 350px;
}
</style>

Color and Text Mapping

The fill color and the text in the data source can be mapped to the chart using pointColorMapping in series and name in datalabel respectively.

<template>
    <div id="app">
        <ejs-accumulationchart id="container">
            <e-accumulation-series-collection>
                <e-accumulation-series :dataSource='seriesData' xName='x' yName='y' :dataLabel='datalabel'
                    :pointColorMapping='pointColorMapping'> </e-accumulation-series>
            </e-accumulation-series-collection>
        </ejs-accumulationchart>
    </div>
</template>
<script setup>
import { provide } from "vue";
import { AccumulationChartComponent as EjsAccumulationchart, AccumulationSeriesCollectionDirective as EAccumulationSeriesCollection, AccumulationSeriesDirective as EAccumulationSeries, PieSeries, AccumulationDataLabel } from "@syncfusion/ej2-vue-charts";


const seriesData = [
    { x: 'Jan', y: 3, fill: '#498fff', text: 'January' }, { x: 'Feb', y: 3.5, fill: '#ffa060', text: 'February' },
    { x: 'Mar', y: 7, fill: '#ff68b6', text: 'March' }, { x: 'Apr', y: 13.5, fill: '#81e2a1', text: 'April' }
];
const datalabel = { visible: true, name: 'text' };
const pointColorMapping = 'fill';

provide('accumulationchart', [PieSeries, AccumulationDataLabel]);

</script>
<style>
#container {
    height: 350px;
}
</style>
<template>
    <div id="app">
        <ejs-accumulationchart id="container">
            <e-accumulation-series-collection>
                <e-accumulation-series :dataSource='seriesData' xName='x' yName='y' :dataLabel='datalabel'
                    :pointColorMapping='pointColorMapping'> </e-accumulation-series>
            </e-accumulation-series-collection>
        </ejs-accumulationchart>
    </div>
</template>
<script>

import { AccumulationChartComponent, AccumulationSeriesCollectionDirective, AccumulationSeriesDirective, PieSeries, AccumulationDataLabel } from "@syncfusion/ej2-vue-charts";

export default {
    name: "App",
    components: {
        'ejs-accumulationchart': AccumulationChartComponent,
        'e-accumulation-series-collection': AccumulationSeriesCollectionDirective,
        'e-accumulation-series': AccumulationSeriesDirective
    },
    data() {
        return {
            seriesData: [
                { x: 'Jan', y: 3, fill: '#498fff', text: 'January' }, { x: 'Feb', y: 3.5, fill: '#ffa060', text: 'February' },
                { x: 'Mar', y: 7, fill: '#ff68b6', text: 'March' }, { x: 'Apr', y: 13.5, fill: '#81e2a1', text: 'April' }
            ],
            datalabel: { visible: true, name: 'text' },
            pointColorMapping: 'fill'
        };
    },
    provide: {
        accumulationchart: [PieSeries, AccumulationDataLabel]
    }
};
</script>
<style>
#container {
    height: 350px;
}
</style>

Border Radius

You can create rounded corners for each slice using the borderRadius option, giving the chart a modern and polished look.

<template>
  <div id="app">
    <ejs-accumulationchart id='chartcontainer' width='92%' :title='title' :legendSettings='legendSettings'
       :enableAnimation='enableAnimation'>
      <e-accumulation-series-collection>
        <e-accumulation-series :dataSource='seriesData' :startAngle='startAngle' :endAngle='endAngle' :radius='radius'
          xName='x' yName='y' name='Browser' innerRadius='60%' borderRadius='8'> </e-accumulation-series>
      </e-accumulation-series-collection>
    </ejs-accumulationchart>
  </div>
</template>
<script setup>
import { provide } from "vue";
import { AccumulationChartComponent as EjsAccumulationchart, AccumulationSeriesCollectionDirective as EAccumulationSeriesCollection, AccumulationSeriesDirective as EAccumulationSeries, PieSeries, AccumulationLegend } from "@syncfusion/ej2-vue-charts";


const seriesData = [
{ x: 'Argentina', y: 505370, r: '100' },
        { x: 'Belgium', y: 551500, r: '118.7' },
        { x: 'Cuba', y: 312685, r: '124.6' },
        { x: 'Dominican Republic', y: 350000, r: '137.5' },
        { x: 'Egypt', y: 301000, r: '150.8' },
        { x: 'Kazakhstan', y: 300000, r: '155.5' },
        { x: 'Somalia', y: 357022, r: '160.6' }
];
const enableAnimation = true;
const legendSettings = {
  visible: false,
};
const startAngle = '0';
const endAngle = '360';
const radius = '70%';
const title = "Mobile Browser Statistics";

provide('accumulationchart', [PieSeries, AccumulationLegend]);

</script>
<style>
#container {
  height: 350px;
}
</style>
<template>
  <div id="app">
    <ejs-accumulationchart id='chartcontainer' width='92%' :title='title' :legendSettings='legendSettings' :tooltip='tooltip'
       :enableAnimation='enableAnimation'>
      <e-accumulation-series-collection>
        <e-accumulation-series :dataSource='seriesData' :startAngle='startAngle' :endAngle='endAngle' :radius='radius'
          xName='x' yName='y' :dataLabel='dataLabel' name='Browser' innerRadius='60%' borderRadius='8'> </e-accumulation-series>
      </e-accumulation-series-collection>
    </ejs-accumulationchart>
  </div>
</template>
<script>

import { AccumulationChartComponent, AccumulationSeriesCollectionDirective, AccumulationSeriesDirective, PieSeries, AccumulationLegend } from "@syncfusion/ej2-vue-charts";

export default {
  name: "App",
  components: {
    'ejs-accumulationchart': AccumulationChartComponent,
    'e-accumulation-series-collection': AccumulationSeriesCollectionDirective,
    'e-accumulation-series': AccumulationSeriesDirective
  },
  data() {
    return {
      seriesData: [
      { x: 'Argentina', y: 505370, r: '100' },
        { x: 'Belgium', y: 551500, r: '118.7' },
        { x: 'Cuba', y: 312685, r: '124.6' },
        { x: 'Dominican Republic', y: 350000, r: '137.5' },
        { x: 'Egypt', y: 301000, r: '150.8' },
        { x: 'Kazakhstan', y: 300000, r: '155.5' },
        { x: 'Somalia', y: 357022, r: '160.6' }
      ],
      enableAnimation: true,
      legendSettings: {
        visible: false,
      },
      startAngle: '0',
      endAngle: '360',
      title: "Mobile Browser Statistics"
    };
  },
  provide: {
    accumulationchart: [PieSeries, AccumulationDataLabel, AccumulationLegend]
  }
};
</script>
<style>
#container {
  height: 350px;
}
</style>

Patterns

You can apply different patterns to the pie slices using the applyPattern property in the series and the pointRender event.

<template>
  <div id="app">
    <ejs-accumulationchart id='chartcontainer' width='92%' :title='title' :legendSettings='legendSettings'
       :enableAnimation='enableAnimation'>
      <e-accumulation-series-collection>
        <e-accumulation-series :dataSource='seriesData' :startAngle='startAngle' :endAngle='endAngle' :radius='radius'
          xName='x' yName='y' name='Browser' innerRadius='60%' borderRadius='8'> </e-accumulation-series>
      </e-accumulation-series-collection>
    </ejs-accumulationchart>
  </div>
</template>
<script setup>
import { provide } from "vue";
import { AccumulationChartComponent as EjsAccumulationchart, AccumulationSeriesCollectionDirective as EAccumulationSeriesCollection, AccumulationSeriesDirective as EAccumulationSeries, PieSeries, AccumulationLegend } from "@syncfusion/ej2-vue-charts";


const seriesData = [
{ x: 'Argentina', y: 505370, r: '100' },
        { x: 'Belgium', y: 551500, r: '118.7' },
        { x: 'Cuba', y: 312685, r: '124.6' },
        { x: 'Dominican Republic', y: 350000, r: '137.5' },
        { x: 'Egypt', y: 301000, r: '150.8' },
        { x: 'Kazakhstan', y: 300000, r: '155.5' },
        { x: 'Somalia', y: 357022, r: '160.6' }
];
const enableAnimation = true;
const legendSettings = {
  visible: false,
};
const startAngle = '0';
const endAngle = '360';
const radius = '70%';
const title = "Mobile Browser Statistics";

provide('accumulationchart', [PieSeries, AccumulationLegend]);

</script>
<style>
#container {
  height: 350px;
}
</style>
<template>
  <div id="app">
    <ejs-accumulationchart id='chartcontainer' width='92%' :title='title' :legendSettings='legendSettings' :tooltip='tooltip'
       :enableAnimation='enableAnimation'>
      <e-accumulation-series-collection>
        <e-accumulation-series :dataSource='seriesData' :startAngle='startAngle' :endAngle='endAngle' :radius='radius'
          xName='x' yName='y' :dataLabel='dataLabel' name='Browser' innerRadius='60%' borderRadius='8'> </e-accumulation-series>
      </e-accumulation-series-collection>
    </ejs-accumulationchart>
  </div>
</template>
<script>

import { AccumulationChartComponent, AccumulationSeriesCollectionDirective, AccumulationSeriesDirective, PieSeries, AccumulationLegend } from "@syncfusion/ej2-vue-charts";

export default {
  name: "App",
  components: {
    'ejs-accumulationchart': AccumulationChartComponent,
    'e-accumulation-series-collection': AccumulationSeriesCollectionDirective,
    'e-accumulation-series': AccumulationSeriesDirective
  },
  data() {
    return {
      seriesData: [
      { x: 'Argentina', y: 505370, r: '100' },
        { x: 'Belgium', y: 551500, r: '118.7' },
        { x: 'Cuba', y: 312685, r: '124.6' },
        { x: 'Dominican Republic', y: 350000, r: '137.5' },
        { x: 'Egypt', y: 301000, r: '150.8' },
        { x: 'Kazakhstan', y: 300000, r: '155.5' },
        { x: 'Somalia', y: 357022, r: '160.6' }
      ],
      enableAnimation: true,
      legendSettings: {
        visible: false,
      },
      startAngle: '0',
      endAngle: '360',
      title: "Mobile Browser Statistics"
    };
  },
  provide: {
    accumulationchart: [PieSeries, AccumulationDataLabel, AccumulationLegend]
  }
};
</script>
<style>
#container {
  height: 350px;
}
</style>

Multi-level pie chart

You can achieve a multi-level drill down in pie and doughnut charts using pointClick event. If user clicks any point in the chart, that corresponding data will be shown in the next level and so on based on point clicked.

You can also achieve drill-up (back to the initial state) by using chartMouseClick event. In below sample, you can drill-up by clicking back button in the center of the chart.

<template>
    <div id="app">
    <div>
        <div id="link">
            <a id="category" @click="onClick" style="visibility:hidden; display:inline-block">Sales by Category</a>
            <p style="visibility:hidden; display:inline-block" id="symbol"> >> </p>
            <p id="text" style="display:inline-block;"></p>
        </div>
        <button type="button" id="back" style="visibility: hidden;" @click="onClick">Back</button>
        <ejs-accumulationchart ref="pie" id="container" style='display:block;' :legendSettings="legendSettings" :enableSmartLabels='enableSmartLabels' :title="title" :textRender="onTextRender" :chartMouseClick="onChartMouseClick">
            <e-accumulation-series-collection>
                <e-accumulation-series :dataSource='data' xName='x' yName='y' :startAngle="startAngle" :endAngle="endAngle" :innerRadius="innerRadius" radius="70%" :dataLabel="dataLabel" :explode="isExplode" explodeOffset='10%' :explodeIndex='explodeIndex'>
                </e-accumulation-series>
            </e-accumulation-series-collection>
        </ejs-accumulationchart>
    </div>
    </div>
</template>
<script setup>
import { provide, ref } from "vue";

import { extend } from '@syncfusion/ej2-base';
import { getElement, indexFinder, AccumulationLegend, PieSeries, AccumulationTooltip, AccumulationDataLabel, AccumulationChartComponent as EjsAccumulationchart,
    AccumulationSeriesCollectionDirective as EAccumulationSeriesCollection, AccumulationSeriesDirective as EAccumulationSeries
 } from "@syncfusion/ej2-vue-charts";

 const pie = ref(null);

const innerRadius = ref('0%');
const innerChart = ref(false);
const enableSmartLabels = ref(false);

const data = ref([
    { x: 'SUV', y: 25 }, { x: 'Car', y: 37 }, { x: 'Pickup', y: 15 },
    { x: 'Minivan', y: 23 }
]);

const suvs = ref([{ x: 'Toyota', y: 8 }, { x: 'Ford', y: 12 }, { x: 'GM', y: 17 }, { x: 'Renault', y: 6 }, { x: 'Fiat', y: 3 },
{ x: 'Hyundai', y: 16 }, { x: 'Honda', y: 8 }, { x: 'Maruthi', y: 10 }, { x: 'BMW', y: 20 }]);

const cars = ref([{ x: 'Toyota', y: 7 }, { x: 'Chrysler', y: 12 }, { x: 'Nissan', y: 9 }, { x: 'Ford', y: 15 },
{ x: 'Tata', y: 10 },
{ x: 'Mahindra', y: 7 }, { x: 'Renault', y: 8 }, { x: 'Skoda', y: 5 }, { x: 'Volkswagen', y: 15 }, { x: 'Fiat', y: 3 }]);

const pickups = ref([{ x: 'Nissan', y: 9 }, { x: 'Chrysler', y: 4 }, { x: 'Ford', y: 7 }, { x: 'Toyota', y: 20 },
{ x: 'Suzuki', y: 13 }, { x: 'Lada', y: 12 }, { x: 'Bentley', y: 6 }, { x: 'Volvo', y: 10 }, { x: 'Audi', y: 19 }]);

const minivans = ref([{ x: 'Hummer', y: 11 }, { x: 'Ford', y: 5 }, { x: 'GM', y: 12 }, { x: 'Chrysler', y: 3 },
{ x: 'Jaguar', y: 9 },
{ x: 'Fiat', y: 8 }, { x: 'Honda', y: 15 }, { x: 'Hyundai', y: 4 }, { x: 'Scion', y: 11 }, { x: 'Toyota', y: 17 }]);

const legendSettings = ref({
    visible: false,
});

const dataLabel = ref({
    visible: true, position: 'Inside', connectorStyle: { type: 'Curve', length: '5%' }, font: { size: '14px', color: 'white' }
});

const startAngle = ref(0);

const explodeIndex = ref(2);

const isExplode = ref(false);

const endAngle = ref(360);

const title = ref('Automobile Sales by Category');

provide('accumulationchart',  [AccumulationLegend, PieSeries, AccumulationTooltip, AccumulationDataLabel]);

const onTextRender = (args) => {
    args.text = args.point.x + ' ' + args.point.y + ' %';
};

const onChartMouseClick = (args) => {
    let index = indexFinder(args.target);
    isExplode.value = false;
    if (getElement('container_Series_' + index.series + '_Point_' + index.point) && !innerChart.value) {
        innerRadius.value = '30%';
        switch (index.point) {
            case 0:
                data.value = suvs.value;
                title.value = 'Automobile Sales in the SUV Segment';
                getElement('text').innerHTML = 'SUV';
                break;
            case 1:
                data.value = cars.value;
                title.value = 'Automobile Sales in the Car Segment';
                getElement('text').innerHTML = 'Car';
                break;
            case 2:
                data.value = pickups.value;
                title.value = 'Automobile Sales in the Pickup Segment';
                getElement('text').innerHTML = 'Pickup';
                break;
            case 3:
                data.value = minivans.value;
                title.value = 'Automobile Sales in the Minivan Segment';
                getElement('text').innerHTML = 'Minivan';
                break;
        }
        let dataLabel = extend({}, dataLabel.value);
        dataLabel.position = 'Outside';
        dataLabel.font.color = 'black';
        dataLabel.value = dataLabel;
        let legendSettings = legendSettings.value;
        legendSettings.visible = false;
        legendSettings.value = legendSettings;
        enableSmartLabels.value = true;
        getElement('category').style.visibility = 'visible';
        getElement('symbol').style.visibility = 'visible';
        getElement('text').style.visibility = 'visible';
        innerChart.value = true;
    }
    if (args.target.indexOf('back') > -1) {
        data.value = [{ x: 'SUV', y: 25 }, { x: 'Car', y: 37 }, { x: 'Pickup', y: 15 }, { x: 'Minivan', y: 23 }]
        isExplode.value = false;
        let dataLabel = extend({}, dataLabel.value);
        dataLabel.position = 'Inside';
        dataLabel.font.color = 'white';
        dataLabel.value = dataLabel;
        let legendSettings = legendSettings.value;
        legendSettings.visible = false;
        legendSettings.value = legendSettings;
        enableSmartLabels.value = false;
        innerRadius.value = '0%';
        getElement('category').style.visibility = 'hidden';
        getElement('symbol').style.visibility = 'hidden';
        getElement('text').style.visibility = 'hidden';
        innerChart.value = false;
    }
};

const onClick = (e) => {
    isExplode.value = false;
    data.value = [{ x: 'SUV', y: 25 }, { x: 'Car', y: 37 }, { x: 'Pickup', y: 15 }, { x: 'Minivan', y: 23 }]
    let dataLabel = extend({}, dataLabel.value);
    dataLabel.position = 'Inside';
    dataLabel.font.color = 'white';
    dataLabel.value = dataLabel;
    let legendSettings = legendSettings.value;
    legendSettings.visible = false;
    legendSettings.value = legendSettings;
    enableSmartLabels.value = false;
    innerRadius.value = '0%';
    getElement('category').style.visibility = 'hidden';
    getElement('symbol').style.visibility = 'hidden';
    getElement('text').style.visibility = 'hidden';
    e.target.style.visibility = 'hidden';
    getElement('symbol').style.visibility = 'hidden';
    getElement('text').style.visibility = 'hidden';
    innerChart.value = false;
};

provide('accumulationchart',  [AccumulationLegend, PieSeries, AccumulationTooltip, AccumulationDataLabel]);


</script>

<style scoped>
#category:hover {
    cursor: pointer;
}
</style>
<template>
    <div id="app">
    <div>
        <div id="link">
            <a id="category" @click="onClick" style="visibility:hidden; display:inline-block">Sales by Category</a>
            <p style="visibility:hidden; display:inline-block" id="symbol"> >> </p>
            <p id="text" style="display:inline-block;"></p>
        </div>
        <button type="button" id="back" style="visibility: hidden;" @click="onClick">Back</button>
        <ejs-accumulationchart ref="pie" id="container" style='display:block;' :legendSettings="legendSettings" :enableSmartLabels='enableSmartLabels' :title="title" :textRender="onTextRender" :chartMouseClick="onChartMouseClick">
            <e-accumulation-series-collection>
                <e-accumulation-series :dataSource='data' xName='x' yName='y' :startAngle="startAngle" :endAngle="endAngle" :innerRadius="innerRadius" radius="70%" :dataLabel="dataLabel" :explode="isExplode" explodeOffset='10%' :explodeIndex='explodeIndex'>
                </e-accumulation-series>
            </e-accumulation-series-collection>
        </ejs-accumulationchart>
    </div>
    </div>
</template>
<script>

import { extend } from '@syncfusion/ej2-base';
import { getElement, indexFinder, AccumulationLegend, PieSeries, AccumulationTooltip, AccumulationDataLabel, AccumulationChartComponent,
    AccumulationSeriesCollectionDirective, AccumulationSeriesDirective
 } from "@syncfusion/ej2-vue-charts";


export default {
name: "App",
components: {
"ejs-accumulationchart":AccumulationChartComponent,
"e-accumulation-series-collection":AccumulationSeriesCollectionDirective,
"e-accumulation-series":AccumulationSeriesDirective,

},

  data() {
    return {
      innerRadius: '0%',
    innerChart: false,
    enableSmartLabels: false,
    data: [
        { x: 'SUV', y: 25 }, { x: 'Car', y: 37 }, { x: 'Pickup', y: 15 },
        { x: 'Minivan', y: 23 }
    ],
    suvs: [{ x: 'Toyota', y: 8 }, { x: 'Ford', y: 12 }, { x: 'GM', y: 17 }, { x: 'Renault', y: 6 }, { x: 'Fiat', y: 3 },
    { x: 'Hyundai', y: 16 }, { x: 'Honda', y: 8 }, { x: 'Maruthi', y: 10 }, { x: 'BMW', y: 20 }],

    cars: [{ x: 'Toyota', y: 7 }, { x: 'Chrysler', y: 12 }, { x: 'Nissan', y: 9 }, { x: 'Ford', y: 15 },
    { x: 'Tata', y: 10 },
    { x: 'Mahindra', y: 7 }, { x: 'Renault', y: 8 }, { x: 'Skoda', y: 5 }, { x: 'Volkswagen', y: 15 }, { x: 'Fiat', y: 3 }],

    pickups: [{ x: 'Nissan', y: 9 }, { x: 'Chrysler', y: 4 }, { x: 'Ford', y: 7 }, { x: 'Toyota', y: 20 },
    { x: 'Suzuki', y: 13 }, { x: 'Lada', y: 12 }, { x: 'Bentley', y: 6 }, { x: 'Volvo', y: 10 }, { x: 'Audi', y: 19 }],

    minivans: [{ x: 'Hummer', y: 11 }, { x: 'Ford', y: 5 }, { x: 'GM', y: 12 }, { x: 'Chrysler', y: 3 },
    { x: 'Jaguar', y: 9 },
    { x: 'Fiat', y: 8 }, { x: 'Honda', y: 15 }, { x: 'Hyundai', y: 4 }, { x: 'Scion', y: 11 }, { x: 'Toyota', y: 17 }],

    legendSettings: {
        visible: false,
    },
    dataLabel: {
        visible: true, position: 'Inside', connectorStyle: { type: 'Curve', length: '5%' }, font: { size: '14px', color: 'white' }
    },
    startAngle: 0,
    explodeIndex: 2,
    isExplode: false,
    endAngle: 360,
    title: 'Automobile Sales by Category'
    }
  },
  provide: {
     accumulationchart: [AccumulationLegend, PieSeries, AccumulationTooltip, AccumulationDataLabel]
  },
   methods: {
    onTextRender: function (args) {
        args.text = args.point.x + ' ' + args.point.y + ' %';
    },
    onChartMouseClick: function (args) {
        const index = indexFinder(args.target);
        this.isExplode = false;
        const pointElement = document.getElementById('container_Series_' + index.series + '_Point_' + index.point);
        if (pointElement && !this.innerChart) {
            this.innerRadius = '30%';
            switch (index.point) {
                case 0:
                    this.data = this.suvs;
                    this.title = 'Automobile Sales in the SUV Segment';
                    document.getElementById('text').innerHTML = 'SUV';
                    break;
                case 1:
                    this.data = this.cars;
                    this.title = 'Automobile Sales in the Car Segment';
                    document.getElementById('text').innerHTML = 'Car';
                    break;
                case 2:
                    this.data = this.pickups;
                    this.title = 'Automobile Sales in the Pickup Segment';
                    document.getElementById('text').innerHTML = 'Pickup';
                    break;
                case 3:
                    this.data = this.minivans;
                    this.title = 'Automobile Sales in the Minivan Segment';
                    document.getElementById('text').innerHTML = 'Minivan';
                    break;
            }
            const dataLabel = extend({}, this.dataLabel);
            dataLabel.position = 'Outside';
            dataLabel.font.color = 'black';
            this.dataLabel = dataLabel;
            const innerLegendSettings = this.legendSettings;
            innerLegendSettings.visible = false;
            this.legendSettings = innerLegendSettings;
            dataLabel.position = 'Inside';
            dataLabel.font.color = 'white';
            this.dataLabel = dataLabel;
            const legendSettings = this.legendSettings;
            legendSettings.visible = false;
            this.legendSettings = legendSettings;
            this.enableSmartLabels = false;
            this.innerRadius = '0%';
            getElement('category').style.visibility = 'hidden';
            document.getElementById('symbol').style.visibility = 'hidden';
            document.getElementById('text').style.visibility = 'hidden';
            this.innerChart = false;
        }
    },
    onClick: function (e) {
        this.isExplode = false;
        this.data = [{ x: 'SUV', y: 25 }, { x: 'Car', y: 37 }, { x: 'Pickup', y: 15 }, { x: 'Minivan', y: 23 }]
        const dataLabel = extend({}, this.dataLabel);
        dataLabel.position = 'Inside';
        dataLabel.font.color = 'white';
        this.dataLabel = dataLabel;
        const legendSettings = this.legendSettings;
        legendSettings.visible = false;
        this.legendSettings = legendSettings;
        this.enableSmartLabels = false;
        this.innerRadius = '0%';
        getElement('category').style.visibility = 'hidden';
        document.getElementById('symbol').style.visibility = 'hidden';
        document.getElementById('text').style.visibility = 'hidden';
        e.target.style.visibility = 'hidden';
        document.getElementById('symbol').style.visibility = 'hidden';
        document.getElementById('text').style.visibility = 'hidden';
        this.innerChart = false;
    },
  }
  };

</script>

<style scoped>
#category:hover {
    cursor: pointer;
}
</style>